'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mime = require('./mime/mime');

var _mime2 = _interopRequireDefault(_mime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _checkIsNeedConcat(url) {
    var isNeedConcat = false;
    url.indexOf('??') > 0 ? isNeedConcat = true : isNeedConcat = false;
    return isNeedConcat;
}

var Concat = function () {
    function Concat(options) {
        (0, _classCallCheck3.default)(this, Concat);

        this.options = options;
        this.init = this.init.bind(this);
    }

    (0, _createClass3.default)(Concat, [{
        key: 'concatFile',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(url) {
                var urlSplit, urlPrefix, urlFiles, files, staticPath, fileBufferArray, contentType, i, len, fileI, enter;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                urlSplit = url.split('??');
                                urlPrefix = urlSplit[0];
                                urlFiles = urlSplit[1].split('?')[0];
                                files = urlFiles.split(',');
                                staticPath = this.options.staticPath;
                                fileBufferArray = [];
                                contentType = files[0].split('.')[1];
                                i = 0, len = files.length;

                            case 8:
                                if (!(i < len)) {
                                    _context.next = 17;
                                    break;
                                }

                                _context.next = 11;
                                return _fs2.default.readFileSync(staticPath + urlPrefix + files[i]);

                            case 11:
                                fileI = _context.sent;

                                if (i > 0 && i < len) {
                                    enter = new Buffer.from([0x0a]);

                                    fileBufferArray.push(enter);
                                }
                                fileBufferArray.push(fileI);

                            case 14:
                                i++;
                                _context.next = 8;
                                break;

                            case 17:
                                return _context.abrupt('return', { bf: Buffer.concat(fileBufferArray), contentType: contentType });

                            case 18:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function concatFile(_x) {
                return _ref.apply(this, arguments);
            }

            return concatFile;
        }()
    }, {
        key: 'init',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(ctx, next) {
                var isNeedConcat, concatResult;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                isNeedConcat = _checkIsNeedConcat(ctx.req.url);

                                if (!isNeedConcat) {
                                    _context2.next = 9;
                                    break;
                                }

                                _context2.next = 4;
                                return this.concatFile(ctx.req.url);

                            case 4:
                                concatResult = _context2.sent;

                                ctx.response.set('Content-Type', _mime2.default[concatResult.contentType]);
                                ctx.body = concatResult.bf.toString('utf8');
                                _context2.next = 11;
                                break;

                            case 9:
                                _context2.next = 11;
                                return next();

                            case 11:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function init(_x2, _x3) {
                return _ref2.apply(this, arguments);
            }

            return init;
        }()
    }]);
    return Concat;
}();

exports.default = Concat;